#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Red
#property indicator_color2  White

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    HmaPeriod       = 14;
extern double HmaSpeed        = 2.0;

extern int    Thickness       = 2;
extern bool   HistoOnFirst    = false;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

int    HalfPeriod;
int    HullPeriod;
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[]; 
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               

int init()
{
    IndicatorBuffers(5);
    SetIndexBuffer(0, Buffer3); SetIndexStyle(0,DRAW_HISTOGRAM,0,Thickness);
    SetIndexBuffer(1, Buffer4); SetIndexStyle(1,DRAW_HISTOGRAM,0,Thickness);
    SetIndexBuffer(2, Buffer1); 
    SetIndexBuffer(3, Buffer2); 
    SetIndexBuffer(4, trend);      
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"   Randy Candles");   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);  
          if (returnBars) { Buffer1[0] = limit+1; return(0); }   
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for (pos=limit; pos >= 0; pos--)
     {                    
         double maOpen  = iHull(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN, pos),HmaPeriod,pos,0);
         double maClose = iHull(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,pos),HmaPeriod,pos,1);
         double maLow   = iHull(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW,  pos),HmaPeriod,pos,2);
         double maHigh  = iHull(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH, pos),HmaPeriod,pos,3);
         
         double haClose = (maOpen+maHigh+maLow+maClose)/4;
         double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
         double haHigh  = MathMax(maHigh,MathMax(haOpen,haClose));
         double haLow   = MathMin(maLow, MathMin(haOpen,haClose));
          
         if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]=haOpen;
                               Buffer4[pos]=haClose;   
          
         trend[pos] = trend[pos+1];
         if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
         if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;    
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   int displace = -1; if (HistoOnFirst) displace = 1;
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(pos = limit; pos >= 0; pos--)
   {
      int y = iBarShift(NULL,timeFrame,Time[pos]);
      int x = iBarShift(NULL,timeFrame,Time[pos+displace]);
         trend[pos]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaPeriod,HmaSpeed,4,y); 
         if (x!=y)
         { 
           Buffer3[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaPeriod,HmaSpeed,0,y);
           Buffer4[pos] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HmaPeriod,HmaSpeed,1,y);
         }      
   }
   manageAlerts();
   return(0);         
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Heiken Ashi Hull  ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi Hull "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

double workHull[][8];
double iHull(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workHull,0)!= Bars) ArrayResize(workHull,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //

      int HmaPeriod  = MathMax(period,2);
      int HalfPeriod = MathFloor(HmaPeriod/HmaSpeed);
      int HullPeriod = MathFloor(MathSqrt(HmaPeriod));
      double hma,hmw,weight; instanceNo *= 2;

         workHull[r][instanceNo] = price;

         //
         //
         //
         //
         //
               
         hmw = HalfPeriod; hma = hmw*price; 
            for(int k=1; k<HalfPeriod && (r-k)>=0; k++)
            {
               weight = HalfPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];  
            }             
            workHull[r][instanceNo+1] = 2.0*hma/hmw;

         hmw = HmaPeriod; hma = hmw*price; 
            for(k=1; k<period && (r-k)>=0; k++)
            {
               weight = HmaPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][instanceNo];
            }             
            workHull[r][instanceNo+1] -= hma/hmw;

         //
         //
         //
         //
         //
         
         hmw = HullPeriod; hma = hmw*workHull[r][instanceNo+1];
            for(k=1; k<HullPeriod && (r-k)>=0; k++)
            {
               weight = HullPeriod-k;
               hmw   += weight;
               hma   += weight*workHull[r-k][1+instanceNo];  
            }
   return(hma/hmw);
}

